/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Accelerometer.h"
#include "com_phidget22_AccelerometerBase.h"

static jclass accelerometer_class;
extern jfieldID phidget_handle_fid;

static jclass accelerationChangeEvent_class;
static jmethodID fireAccelerationChange_mid	;
static jmethodID accelerationChangeEvent_cons;
static jfieldID nativeAccelerationChangeHandler_fid;

void com_phidget22_AccelerometerBase_OnLoad(JNIEnv *env) {
	if (!(accelerometer_class = (*env)->FindClass(env, "com/phidget22/AccelerometerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/AccelerometerBase");
	if (!(accelerometer_class = (jclass)(*env)->NewGlobalRef(env, accelerometer_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef accelerometer_class");

	if (!(accelerationChangeEvent_class = (*env)->FindClass(env, "com/phidget22/AccelerometerAccelerationChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/AccelerometerAccelerationChangeEvent");
	if (!(accelerationChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, accelerationChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref AccelerationChangeEvent_class");
	if (!(fireAccelerationChange_mid = (*env)->GetMethodID(env, accelerometer_class, "fireAccelerationChange", "(Lcom/phidget22/AccelerometerAccelerationChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireAccelerationChange");
	if (!(accelerationChangeEvent_cons = (*env)->GetMethodID(env, accelerationChangeEvent_class, "<init>", "(Lcom/phidget22/Accelerometer;[DD)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from AccelerationChangeEvent_class");
	if (!(nativeAccelerationChangeHandler_fid = (*env)->GetFieldID(env, accelerometer_class, "nativeAccelerationChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeAccelerationChangeHandler from accelerometer_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_AccelerometerBase_create(JNIEnv * env, jclass obj) {
	PhidgetAccelerometerHandle phid;
	int error; 
	if ((error = PhidgetAccelerometer_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double acceleration[3];
	jdoubleArray jacceleration = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetAccelerometer_getAcceleration(h, &acceleration)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jacceleration, 0, (jsize)3, acceleration);
	return jacceleration;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getMinAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minAcceleration[3];
	jdoubleArray jminAcceleration = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetAccelerometer_getMinAcceleration(h, &minAcceleration)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jminAcceleration, 0, (jsize)3, minAcceleration);
	return jminAcceleration;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getMaxAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxAcceleration[3];
	jdoubleArray jmaxAcceleration = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetAccelerometer_getMaxAcceleration(h, &maxAcceleration)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jmaxAcceleration, 0, (jsize)3, maxAcceleration);
	return jmaxAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double accelerationChangeTrigger;
	if ((error = PhidgetAccelerometer_getAccelerationChangeTrigger(h, &accelerationChangeTrigger)))
		PH_THROW(error);
	return accelerationChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setAccelerationChangeTrigger(JNIEnv * env, jobject obj, jdouble accelerationChangeTrigger) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetAccelerometer_setAccelerationChangeTrigger(h, (double)accelerationChangeTrigger)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMinAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minAccelerationChangeTrigger;
	if ((error = PhidgetAccelerometer_getMinAccelerationChangeTrigger(h, &minAccelerationChangeTrigger)))
		PH_THROW(error);
	return minAccelerationChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMaxAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxAccelerationChangeTrigger;
	if ((error = PhidgetAccelerometer_getMaxAccelerationChangeTrigger(h, &maxAccelerationChangeTrigger)))
		PH_THROW(error);
	return maxAccelerationChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getAxisCount(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int axisCount;
	if ((error = PhidgetAccelerometer_getAxisCount(h, &axisCount)))
		PH_THROW(error);
	return axisCount;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetAccelerometer_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetAccelerometer_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetAccelerometer_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetAccelerometer_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getTimestamp(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double timestamp;
	if ((error = PhidgetAccelerometer_getTimestamp(h, &timestamp)))
		PH_THROW(error);
	return timestamp;
}

static void CCONV accelerationChange_handler(PhidgetAccelerometerHandle h, void *arg, const double acceleration[3], double timestamp) {
	jobject accelerationChangeEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray accelerationArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	accelerationArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, accelerationArr, 0, (jsize)3, acceleration);

	if ((accelerationChangeEv = (*env)->NewObject(env, accelerationChangeEvent_class, accelerationChangeEvent_cons, obj, accelerationArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAccelerationChange_mid, accelerationChangeEv);
		(*env)->DeleteLocalRef(env, accelerationChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_enableAccelerationChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeAccelerationChangeHandler_fid, b);
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetAccelerometer_setOnAccelerationChangeHandler(h, b ? accelerationChange_handler : NULL, (void *)(uintptr_t) gr);
}
