/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_CurrentInput.h"
#include "com_phidget22_CurrentInputBase.h"

static jclass currentInput_class;
extern jfieldID phidget_handle_fid;

static jclass currentChangeEvent_class;
static jmethodID fireCurrentChange_mid	;
static jmethodID currentChangeEvent_cons;
static jfieldID nativeCurrentChangeHandler_fid;

void com_phidget22_CurrentInputBase_OnLoad(JNIEnv *env) {
	if (!(currentInput_class = (*env)->FindClass(env, "com/phidget22/CurrentInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CurrentInputBase");
	if (!(currentInput_class = (jclass)(*env)->NewGlobalRef(env, currentInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef currentInput_class");

	if (!(currentChangeEvent_class = (*env)->FindClass(env, "com/phidget22/CurrentInputCurrentChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CurrentInputCurrentChangeEvent");
	if (!(currentChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, currentChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref CurrentChangeEvent_class");
	if (!(fireCurrentChange_mid = (*env)->GetMethodID(env, currentInput_class, "fireCurrentChange", "(Lcom/phidget22/CurrentInputCurrentChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireCurrentChange");
	if (!(currentChangeEvent_cons = (*env)->GetMethodID(env, currentChangeEvent_class, "<init>", "(Lcom/phidget22/CurrentInput;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from CurrentChangeEvent_class");
	if (!(nativeCurrentChangeHandler_fid = (*env)->GetFieldID(env, currentInput_class, "nativeCurrentChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeCurrentChangeHandler from currentInput_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_CurrentInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetCurrentInputHandle phid;
	int error; 
	if ((error = PhidgetCurrentInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double current;
	if ((error = PhidgetCurrentInput_getCurrent(h, &current)))
		PH_THROW(error);
	return current;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMinCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minCurrent;
	if ((error = PhidgetCurrentInput_getMinCurrent(h, &minCurrent)))
		PH_THROW(error);
	return minCurrent;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMaxCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxCurrent;
	if ((error = PhidgetCurrentInput_getMaxCurrent(h, &maxCurrent)))
		PH_THROW(error);
	return maxCurrent;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double currentChangeTrigger;
	if ((error = PhidgetCurrentInput_getCurrentChangeTrigger(h, &currentChangeTrigger)))
		PH_THROW(error);
	return currentChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setCurrentChangeTrigger(JNIEnv * env, jobject obj, jdouble currentChangeTrigger) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetCurrentInput_setCurrentChangeTrigger(h, (double)currentChangeTrigger)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMinCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minCurrentChangeTrigger;
	if ((error = PhidgetCurrentInput_getMinCurrentChangeTrigger(h, &minCurrentChangeTrigger)))
		PH_THROW(error);
	return minCurrentChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMaxCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxCurrentChangeTrigger;
	if ((error = PhidgetCurrentInput_getMaxCurrentChangeTrigger(h, &maxCurrentChangeTrigger)))
		PH_THROW(error);
	return maxCurrentChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetCurrentInput_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetCurrentInput_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetCurrentInput_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetCurrentInput_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_CurrentInputBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_PowerSupply powerSupply;
	if ((error = PhidgetCurrentInput_getPowerSupply(h, &powerSupply)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetCurrentInput_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid))))
		PH_THROW(error);
}

static void CCONV currentChange_handler(PhidgetCurrentInputHandle h, void *arg, double current) {
	jobject currentChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((currentChangeEv = (*env)->NewObject(env, currentChangeEvent_class, currentChangeEvent_cons, obj, current)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCurrentChange_mid, currentChangeEv);
		(*env)->DeleteLocalRef(env, currentChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_enableCurrentChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeCurrentChangeHandler_fid, b);
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetCurrentInput_setOnCurrentChangeHandler(h, b ? currentChange_handler : NULL, (void *)(uintptr_t) gr);
}
