/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_DigitalInput.h"
#include "com_phidget22_DigitalInputBase.h"

static jclass digitalInput_class;
extern jfieldID phidget_handle_fid;

static jclass stateChangeEvent_class;
static jmethodID fireStateChange_mid	;
static jmethodID stateChangeEvent_cons;
static jfieldID nativeStateChangeHandler_fid;

void com_phidget22_DigitalInputBase_OnLoad(JNIEnv *env) {
	if (!(digitalInput_class = (*env)->FindClass(env, "com/phidget22/DigitalInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalInputBase");
	if (!(digitalInput_class = (jclass)(*env)->NewGlobalRef(env, digitalInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalInput_class");

	if (!(stateChangeEvent_class = (*env)->FindClass(env, "com/phidget22/DigitalInputStateChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalInputStateChangeEvent");
	if (!(stateChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, stateChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref StateChangeEvent_class");
	if (!(fireStateChange_mid = (*env)->GetMethodID(env, digitalInput_class, "fireStateChange", "(Lcom/phidget22/DigitalInputStateChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireStateChange");
	if (!(stateChangeEvent_cons = (*env)->GetMethodID(env, stateChangeEvent_class, "<init>", "(Lcom/phidget22/DigitalInput;Z)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from StateChangeEvent_class");
	if (!(nativeStateChangeHandler_fid = (*env)->GetFieldID(env, digitalInput_class, "nativeStateChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeStateChangeHandler from digitalInput_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DigitalInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetDigitalInputHandle phid;
	int error; 
	if ((error = PhidgetDigitalInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalInputBase_getInputMode(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_InputMode inputMode;
	if ((error = PhidgetDigitalInput_getInputMode(h, &inputMode)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, InputMode_class, InputMode_getEnum_mid, inputMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_setInputMode(JNIEnv * env, jobject obj, jobject inputMode) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDigitalInput_setInputMode(h, (Phidget_InputMode)(*env)->CallIntMethod(env, inputMode, InputMode_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalInputBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_PowerSupply powerSupply;
	if ((error = PhidgetDigitalInput_getPowerSupply(h, &powerSupply)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDigitalInput_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_DigitalInputBase_getState(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int state;
	if ((error = PhidgetDigitalInput_getState(h, &state)))
		PH_THROW(error);
	return state;
}

static void CCONV stateChange_handler(PhidgetDigitalInputHandle h, void *arg, int state) {
	jobject stateChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((stateChangeEv = (*env)->NewObject(env, stateChangeEvent_class, stateChangeEvent_cons, obj, state)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireStateChange_mid, stateChangeEv);
		(*env)->DeleteLocalRef(env, stateChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_enableStateChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeStateChangeHandler_fid, b);
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDigitalInput_setOnStateChangeHandler(h, b ? stateChange_handler : NULL, (void *)(uintptr_t) gr);
}
