/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_FrequencyCounter.h"
#include "com_phidget22_FrequencyCounterBase.h"

static jclass frequencyCounter_class;
extern jfieldID phidget_handle_fid;

static jclass frequencyChangeEvent_class;
static jmethodID fireFrequencyChange_mid	;
static jmethodID frequencyChangeEvent_cons;
static jfieldID nativeFrequencyChangeHandler_fid;

static jclass countChangeEvent_class;
static jmethodID fireCountChange_mid	;
static jmethodID countChangeEvent_cons;
static jfieldID nativeCountChangeHandler_fid;

void com_phidget22_FrequencyCounterBase_OnLoad(JNIEnv *env) {
	if (!(frequencyCounter_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterBase");
	if (!(frequencyCounter_class = (jclass)(*env)->NewGlobalRef(env, frequencyCounter_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef frequencyCounter_class");

	if (!(frequencyChangeEvent_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterFrequencyChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterFrequencyChangeEvent");
	if (!(frequencyChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, frequencyChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref FrequencyChangeEvent_class");
	if (!(fireFrequencyChange_mid = (*env)->GetMethodID(env, frequencyCounter_class, "fireFrequencyChange", "(Lcom/phidget22/FrequencyCounterFrequencyChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireFrequencyChange");
	if (!(frequencyChangeEvent_cons = (*env)->GetMethodID(env, frequencyChangeEvent_class, "<init>", "(Lcom/phidget22/FrequencyCounter;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from FrequencyChangeEvent_class");
	if (!(nativeFrequencyChangeHandler_fid = (*env)->GetFieldID(env, frequencyCounter_class, "nativeFrequencyChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeFrequencyChangeHandler from frequencyCounter_class");

	if (!(countChangeEvent_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterCountChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterCountChangeEvent");
	if (!(countChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, countChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref CountChangeEvent_class");
	if (!(fireCountChange_mid = (*env)->GetMethodID(env, frequencyCounter_class, "fireCountChange", "(Lcom/phidget22/FrequencyCounterCountChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireCountChange");
	if (!(countChangeEvent_cons = (*env)->GetMethodID(env, countChangeEvent_class, "<init>", "(Lcom/phidget22/FrequencyCounter;JD)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from CountChangeEvent_class");
	if (!(nativeCountChangeHandler_fid = (*env)->GetFieldID(env, frequencyCounter_class, "nativeCountChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeCountChangeHandler from frequencyCounter_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_FrequencyCounterBase_create(JNIEnv * env, jclass obj) {
	PhidgetFrequencyCounterHandle phid;
	int error; 
	if ((error = PhidgetFrequencyCounter_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jlong JNICALL Java_com_phidget22_FrequencyCounterBase_getCount(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint64_t count;
	if ((error = PhidgetFrequencyCounter_getCount(h, &count)))
		PH_THROW(error);
	return count;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_FrequencyCounterBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int enabled;
	if ((error = PhidgetFrequencyCounter_getEnabled(h, &enabled)))
		PH_THROW(error);
	return enabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setEnabled(h, (int)enabled)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetFrequencyCounter_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetFrequencyCounter_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetFrequencyCounter_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getFilterType(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	PhidgetFrequencyCounter_FilterType filterType;
	if ((error = PhidgetFrequencyCounter_getFilterType(h, &filterType)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, FrequencyFilterType_class, FrequencyFilterType_getEnum_mid, filterType);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setFilterType(JNIEnv * env, jobject obj, jobject filterType) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setFilterType(h, (PhidgetFrequencyCounter_FilterType)(*env)->CallIntMethod(env, filterType, FrequencyFilterType_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getFrequency(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double frequency;
	if ((error = PhidgetFrequencyCounter_getFrequency(h, &frequency)))
		PH_THROW(error);
	return frequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxFrequency(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxFrequency;
	if ((error = PhidgetFrequencyCounter_getMaxFrequency(h, &maxFrequency)))
		PH_THROW(error);
	return maxFrequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double frequencyCutoff;
	if ((error = PhidgetFrequencyCounter_getFrequencyCutoff(h, &frequencyCutoff)))
		PH_THROW(error);
	return frequencyCutoff;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setFrequencyCutoff(JNIEnv * env, jobject obj, jdouble frequencyCutoff) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setFrequencyCutoff(h, (double)frequencyCutoff)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMinFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minFrequencyCutoff;
	if ((error = PhidgetFrequencyCounter_getMinFrequencyCutoff(h, &minFrequencyCutoff)))
		PH_THROW(error);
	return minFrequencyCutoff;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxFrequencyCutoff;
	if ((error = PhidgetFrequencyCounter_getMaxFrequencyCutoff(h, &maxFrequencyCutoff)))
		PH_THROW(error);
	return maxFrequencyCutoff;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getInputMode(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_InputMode inputMode;
	if ((error = PhidgetFrequencyCounter_getInputMode(h, &inputMode)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, InputMode_class, InputMode_getEnum_mid, inputMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setInputMode(JNIEnv * env, jobject obj, jobject inputMode) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setInputMode(h, (Phidget_InputMode)(*env)->CallIntMethod(env, inputMode, InputMode_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_PowerSupply powerSupply;
	if ((error = PhidgetFrequencyCounter_getPowerSupply(h, &powerSupply)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_reset(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetFrequencyCounter_reset(h)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getTimeElapsed(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double timeElapsed;
	if ((error = PhidgetFrequencyCounter_getTimeElapsed(h, &timeElapsed)))
		PH_THROW(error);
	return timeElapsed;
}

static void CCONV countChange_handler(PhidgetFrequencyCounterHandle h, void *arg, uint64_t counts, double timeChange) {
	jobject countChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((countChangeEv = (*env)->NewObject(env, countChangeEvent_class, countChangeEvent_cons, obj, counts, timeChange)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCountChange_mid, countChangeEv);
		(*env)->DeleteLocalRef(env, countChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_enableCountChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeCountChangeHandler_fid, b);
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetFrequencyCounter_setOnCountChangeHandler(h, b ? countChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV frequencyChange_handler(PhidgetFrequencyCounterHandle h, void *arg, double frequency) {
	jobject frequencyChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((frequencyChangeEv = (*env)->NewObject(env, frequencyChangeEvent_class, frequencyChangeEvent_cons, obj, frequency)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireFrequencyChange_mid, frequencyChangeEv);
		(*env)->DeleteLocalRef(env, frequencyChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_enableFrequencyChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeFrequencyChangeHandler_fid, b);
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetFrequencyCounter_setOnFrequencyChangeHandler(h, b ? frequencyChange_handler : NULL, (void *)(uintptr_t) gr);
}
