/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Magnetometer.h"
#include "com_phidget22_MagnetometerBase.h"

static jclass magnetometer_class;
extern jfieldID phidget_handle_fid;

static jclass magneticFieldChangeEvent_class;
static jmethodID fireMagneticFieldChange_mid	;
static jmethodID magneticFieldChangeEvent_cons;
static jfieldID nativeMagneticFieldChangeHandler_fid;

void com_phidget22_MagnetometerBase_OnLoad(JNIEnv *env) {
	if (!(magnetometer_class = (*env)->FindClass(env, "com/phidget22/MagnetometerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MagnetometerBase");
	if (!(magnetometer_class = (jclass)(*env)->NewGlobalRef(env, magnetometer_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef magnetometer_class");

	if (!(magneticFieldChangeEvent_class = (*env)->FindClass(env, "com/phidget22/MagnetometerMagneticFieldChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MagnetometerMagneticFieldChangeEvent");
	if (!(magneticFieldChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, magneticFieldChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref MagneticFieldChangeEvent_class");
	if (!(fireMagneticFieldChange_mid = (*env)->GetMethodID(env, magnetometer_class, "fireMagneticFieldChange", "(Lcom/phidget22/MagnetometerMagneticFieldChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireMagneticFieldChange");
	if (!(magneticFieldChangeEvent_cons = (*env)->GetMethodID(env, magneticFieldChangeEvent_class, "<init>", "(Lcom/phidget22/Magnetometer;[DD)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from MagneticFieldChangeEvent_class");
	if (!(nativeMagneticFieldChangeHandler_fid = (*env)->GetFieldID(env, magnetometer_class, "nativeMagneticFieldChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeMagneticFieldChangeHandler from magnetometer_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_MagnetometerBase_create(JNIEnv * env, jclass obj) {
	PhidgetMagnetometerHandle phid;
	int error; 
	if ((error = PhidgetMagnetometer_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getAxisCount(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int axisCount;
	if ((error = PhidgetMagnetometer_getAxisCount(h, &axisCount)))
		PH_THROW(error);
	return axisCount;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setCorrectionParameters(JNIEnv * env, jobject obj, jdouble magField, jdouble offset0, jdouble offset1, jdouble offset2, jdouble gain0, jdouble gain1, jdouble gain2, jdouble T0, jdouble T1, jdouble T2, jdouble T3, jdouble T4, jdouble T5) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMagnetometer_setCorrectionParameters(h, (double)magField, (double)offset0, (double)offset1, (double)offset2, (double)gain0, (double)gain1, (double)gain2, (double)T0, (double)T1, (double)T2, (double)T3, (double)T4, (double)T5)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetMagnetometer_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMagnetometer_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetMagnetometer_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetMagnetometer_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double magneticField[3];
	jdoubleArray jmagneticField = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetMagnetometer_getMagneticField(h, &magneticField)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jmagneticField, 0, (jsize)3, magneticField);
	return jmagneticField;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMinMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minMagneticField[3];
	jdoubleArray jminMagneticField = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetMagnetometer_getMinMagneticField(h, &minMagneticField)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jminMagneticField, 0, (jsize)3, minMagneticField);
	return jminMagneticField;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMaxMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxMagneticField[3];
	jdoubleArray jmaxMagneticField = (*env)->NewDoubleArray(env, 3);
	if ((error = PhidgetMagnetometer_getMaxMagneticField(h, &maxMagneticField)))
		PH_THROW(error);
	(*env)->SetDoubleArrayRegion(env, jmaxMagneticField, 0, (jsize)3, maxMagneticField);
	return jmaxMagneticField;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double magneticFieldChangeTrigger;
	if ((error = PhidgetMagnetometer_getMagneticFieldChangeTrigger(h, &magneticFieldChangeTrigger)))
		PH_THROW(error);
	return magneticFieldChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setMagneticFieldChangeTrigger(JNIEnv * env, jobject obj, jdouble magneticFieldChangeTrigger) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMagnetometer_setMagneticFieldChangeTrigger(h, (double)magneticFieldChangeTrigger)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMinMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minMagneticFieldChangeTrigger;
	if ((error = PhidgetMagnetometer_getMinMagneticFieldChangeTrigger(h, &minMagneticFieldChangeTrigger)))
		PH_THROW(error);
	return minMagneticFieldChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMaxMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxMagneticFieldChangeTrigger;
	if ((error = PhidgetMagnetometer_getMaxMagneticFieldChangeTrigger(h, &maxMagneticFieldChangeTrigger)))
		PH_THROW(error);
	return maxMagneticFieldChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_resetCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMagnetometer_resetCorrectionParameters(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_saveCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMagnetometer_saveCorrectionParameters(h)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getTimestamp(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double timestamp;
	if ((error = PhidgetMagnetometer_getTimestamp(h, &timestamp)))
		PH_THROW(error);
	return timestamp;
}

static void CCONV magneticFieldChange_handler(PhidgetMagnetometerHandle h, void *arg, const double magneticField[3], double timestamp) {
	jobject magneticFieldChangeEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray magneticFieldArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	magneticFieldArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, magneticFieldArr, 0, (jsize)3, magneticField);

	if ((magneticFieldChangeEv = (*env)->NewObject(env, magneticFieldChangeEvent_class, magneticFieldChangeEvent_cons, obj, magneticFieldArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireMagneticFieldChange_mid, magneticFieldChangeEv);
		(*env)->DeleteLocalRef(env, magneticFieldChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_enableMagneticFieldChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeMagneticFieldChangeHandler_fid, b);
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMagnetometer_setOnMagneticFieldChangeHandler(h, b ? magneticFieldChange_handler : NULL, (void *)(uintptr_t) gr);
}
