/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_VoltageOutput.h"
#include "com_phidget22_VoltageOutputBase.h"

static jclass voltageOutput_class;
extern jfieldID phidget_handle_fid;

void com_phidget22_VoltageOutputBase_OnLoad(JNIEnv *env) {
	if (!(voltageOutput_class = (*env)->FindClass(env, "com/phidget22/VoltageOutputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageOutputBase");
	if (!(voltageOutput_class = (jclass)(*env)->NewGlobalRef(env, voltageOutput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageOutput_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_VoltageOutputBase_create(JNIEnv * env, jclass obj) {
	PhidgetVoltageOutputHandle phid;
	int error; 
	if ((error = PhidgetVoltageOutput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetVoltageOutput_setEnabled(h, (int)enabled)))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_VoltageOutputBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int enabled;
	if ((error = PhidgetVoltageOutput_getEnabled(h, &enabled)))
		PH_THROW(error);
	return enabled;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double voltage;
	if ((error = PhidgetVoltageOutput_getVoltage(h, &voltage)))
		PH_THROW(error);
	return voltage;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltage__D(JNIEnv * env, jobject obj, jdouble voltage) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetVoltageOutput_setVoltage(h, (double)voltage)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltage__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble voltage, jobject asyncHandler) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetVoltageOutput_setVoltage_async(h, (double)voltage, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getMinVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minVoltage;
	if ((error = PhidgetVoltageOutput_getMinVoltage(h, &minVoltage)))
		PH_THROW(error);
	return minVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getMaxVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxVoltage;
	if ((error = PhidgetVoltageOutput_getMaxVoltage(h, &maxVoltage)))
		PH_THROW(error);
	return maxVoltage;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageOutputBase_getVoltageOutputRange(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	PhidgetVoltageOutput_VoltageOutputRange voltageOutputRange;
	if ((error = PhidgetVoltageOutput_getVoltageOutputRange(h, &voltageOutputRange)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, VoltageOutputRange_class, VoltageOutputRange_getEnum_mid, voltageOutputRange);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltageOutputRange(JNIEnv * env, jobject obj, jobject voltageOutputRange) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetVoltageOutput_setVoltageOutputRange(h, (PhidgetVoltageOutput_VoltageOutputRange)(*env)->CallIntMethod(env, voltageOutputRange, VoltageOutputRange_getCode_mid))))
		PH_THROW(error);
}
